=== debian/changelog ===
kamailio (5.1.2-1ubuntu2) bionic; urgency=medium

  * Stop building the kamailio-java-modules package (GCJ based).

 -- Matthias Klose <doko@ubuntu.com>  Wed, 21 Mar 2018 12:13:23 +0800

kamailio (5.1.2-1ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build modules on any platform.
    - Build-depend on db-upgrade-util too.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 11 Mar 2018 22:03:31 +0100

kamailio (5.1.2-1) unstable; urgency=medium

  * New upstream version 5.1.2
  * refresh upstream patches from 5.1

 -- Victor Seva <vseva@debian.org>  Tue, 06 Mar 2018 10:05:17 +0100

kamailio (5.1.1-1ubuntu4) bionic; urgency=medium

  * Rebuild against new libunistring 0.9.9.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 04 Mar 2018 09:22:55 +0100

kamailio (5.1.1-1ubuntu3) bionic; urgency=medium

  * No-change rebuild against libcurl4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2018 07:02:35 +0000

kamailio (5.1.1-1ubuntu2) bionic; urgency=medium

  * Rebuild against new libunistring2.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 13 Feb 2018 16:27:58 +0100

kamailio (5.1.1-1ubuntu1) bionic; urgency=medium

  * Merge with Debian; remaining changes:

 -- Matthias Klose <doko@ubuntu.com>  Thu, 08 Feb 2018 13:49:53 +0100

kamailio (5.1.1-1) unstable; urgency=medium

  [ Victor Seva ]
  * update Vcs-* to salsa.debian.org
  * New upstream version 5.1.1 (Closes: #886110)
  * kamailio.service fix for /run in tmpfs (Closes: #837678)
  * update upstream fixes from 5.1 branch
  * fix debian-control-has-obsolete-dbg-package
  * build-depends-on-obsolete-package build-depends
  * fix debian-rules-parses-dpkg-parsechangelog
  * fix debian-rules-sets-dpkg-architecture-variable
  * fix wildcard-matches-nothing-in-dep5-copyright src/core/
  * fix wildcard-matches-nothing-in-dep5-copyright modules/usrloc/ul_rpc.*
  * fix debian-watch-uses-insecure-uri
  * fix lintian warnings
  * fix missing examples

  [ Guillem Jover ]
  * Wait for kamailio to exit before returning on sysvinit stop action
    (Closes: #889745)

 -- Victor Seva <vseva@debian.org>  Wed, 07 Feb 2018 18:03:02 +0100

kamailio (5.1.0-1) unstable; urgency=medium

  * New upstream version 5.1.0
  * update backports scripts
  * new packages from 5.1.0
  * rules: remove usr/local from kamailio package
  * upstream fixes from 5.1 branch

 -- Victor Seva <vseva@debian.org>  Thu, 14 Dec 2017 19:20:49 +0100

kamailio (5.0.4-1ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build modules on any platform.
    - Build-depend on db-upgrade-util too.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 26 Oct 2017 13:31:24 -0700

kamailio (5.0.4-1) unstable; urgency=medium

  * [767c033] New upstream version 5.0.4

 -- Victor Seva <vseva@debian.org>  Thu, 26 Oct 2017 09:19:06 +0200

kamailio (5.0.3-1) unstable; urgency=medium

  * [384a20d] New upstream version 5.0.3

 -- Victor Seva <vseva@debian.org>  Sun, 01 Oct 2017 12:47:02 +0200

kamailio (5.0.2-2) unstable; urgency=medium

  * [66caa28] fix LIBDIR (Closes:#868270)

 -- Victor Seva <vseva@debian.org>  Fri, 28 Jul 2017 12:36:08 +0200

kamailio (5.0.2-1) unstable; urgency=medium

  * [08870e2] New upstream version 5.0.0
  * [39e76f7] New upstream version 5.0.1
  * [d488c00] update debian copyright
  * [40bf66b] remove purple module
  * [34cc1c9] update descriptions and add new modules
  * [36254e2] remove already applied patches
  * [6289654] New upstream version 5.0.2
  * [39af62d] refresh debian patches
  * [a56ccda] set LIBDIR for all rules

 -- Victor Seva <vseva@debian.org>  Mon, 19 Jun 2017 09:04:29 +0200

kamailio (4.4.4-3) unstable; urgency=medium

  * [5e65291] tls: fix init checks (Closes: #844548)

 -- Victor Seva <vseva@debian.org>  Fri, 31 Mar 2017 15:44:17 +0200

kamailio (4.4.2-3ubuntu5) artful; urgency=medium

  * No-change rebuild against libevent-2.1-6

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 31 Jul 2017 02:44:27 +0000

kamailio (4.4.2-3ubuntu4) artful; urgency=medium

  * No-change rebuild for perl 5.26.0.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 26 Jul 2017 20:03:25 +0000

kamailio (4.4.2-3ubuntu3) zesty; urgency=medium

  * No-change rebuild for perl 5.24 transition

 -- Iain Lane <iain@orangesquash.org.uk>  Mon, 24 Oct 2016 10:09:58 +0100

kamailio (4.4.2-3ubuntu2) yakkety; urgency=medium

  * No-change rebuild for readline soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 17 Sep 2016 12:04:44 +0000

kamailio (4.4.2-3ubuntu1) yakkety; urgency=medium

  * Merge with Debian; remaining changes:
    - Build modules on any platform.
    - Build-depend on db-upgrade-util too.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 08 Aug 2016 13:29:02 +0200

kamailio (4.4.0-3ubuntu2) yakkety; urgency=medium

  * No-change rebuild for libval soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 04 May 2016 19:04:30 +0000

kamailio (4.4.0-3ubuntu1) yakkety; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/control:
      + Build modules on any platform.
      + Use db-upgrade-util instead of hard coding dbX.Y-util
        dependency.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 28 Apr 2016 00:25:53 +0200
